Unable to load Setup of mojo-2.4.0.8 on Apache-2.2 mod_mono

Post here for help with installing or upgrading mojoPortal pre-compiled release packages. When posting in this forum, please provide all relevant details. You may also want to review the installation or upgrading documentation.

If you have questions about using the source code or working with mojoPortal in Visual Studio, please post in the Developer forum.

Post here for help with installation of mojoPortal pre-compiled release packages

When posting in this forum, please try to provide as many relevant details as possible. Particularly the following:

  • What operating system were you running when the bug appeared?
  • What database platform is your site using?
  • What version of mojoPortal are you running?
  • What version of .NET do you use?
  • What steps are necessary to reproduce the issue? Compare expected results vs actual results.

You may also want to review the installation or upgrading documentation.

If you have questions about using the source code or working with mojoPortal in Visual Studio, please post in the Developer forum.

This thread is closed to new posts. You must sign in to post in the forums.
2/25/2015 6:53:24 PM
Gravatar
Total Posts 18

Unable to load Setup of mojo-2.4.0.8 on Apache-2.2 mod_mono

Hi,

I'm trying to install mojoPortal on a Linux server with a mono/mod_mono configuration but get an Error 500 at once when I try to load the Setup page.

OS: Gentoo Linux

DB: Mysql

mojo: 2.4.0.8

NET: 4.5

Web Server: Apache-2.2.29 mono-3.12, mod_mono-3.12, xsp-latest from git (3.0.11)

Mono server seem to work or at least I can run the test pages successfully, but when I try to load my.site.com/Setup/ I get an Error 500 and this message:

Exception during TraceManager initialization:
System.Configuration.ConfigurationErrorsException: The section <system.webServer> is defined more than once in the same configuration file. (/var/www/mono/Web.config line 1002)

I leave out the rest as obviously looks like a configuration file bug or? I'm very new to ASP.NET and I cannot really tell if the above is valid or not i.e if mojo or mono is at fault. When I remove the first <system.webServer> section, starting on line 990, I get a bit further but not far and I don't know if next error is due to the removed config code or if it's a real valid error:


Application Exception

System.TypeLoadException
Could not load type 'mojoPortal.Web.MonoCompilationSection, mojoPortal.Web'.

Description: HTTP 500.Error processing request.

Details: Non-web exception. Exception origin (name of application or object): mscorlib.

Exception stack trace:

at (wrapper managed-to-native) System.Type:internal_from_name (string,bool,bool) at System.Type.GetType (System.String typeName, Boolean throwOnError) [0x00011] in /var/tmp/portage/dev-lang/mono-3.12.0/work/mono-3.12.0/mcs/class/corlib/System/Type.cs:681 at Mono.Web.Util.SettingsMapping.get_MapperType () [0x00011] in /var/tmp/portage/dev-lang/mono-3.12.0/work/mono-3.12.0/mcs/class/System.Web/Mono.Web.Util/SettingsMapping.cs:65 at Mono.Web.Util.SettingsMapping.MapSection (System.Object input, System.Type type) [0x00021] in /var/tmp/portage/dev-lang/mono-3.12.0/work/mono-3.12.0/mcs/class/System.Web/Mono.Web.Util/SettingsMapping.cs:96 at Mono.Web.Util.SettingsMappingManager.MapSection (System.Object input, System.Type type) [0x0004b] in /var/tmp/portage/dev-lang/mono-3.12.0/work/mono-3.12.0/mcs/class/System.Web/Mono.Web.Util/SettingsMappingManager.cs:182 at Mono.Web.Util.SettingsMappingManager.MapSection (System.Object input) [0x00026] in /var/tmp/portage/dev-lang/mono-3.12.0/work/mono-3.12.0/mcs/class/System.Web/Mono.Web.Util/SettingsMappingManager.cs:161 at System.Web.Configuration.WebConfigurationManager.GetSection (System.String sectionName, System.String path, System.Web.HttpContext context) [0x0020a] in /var/tmp/portage/dev-lang/mono-3.12.0/work/mono-3.12.0/mcs/class/System.Web/System.Web.Configuration_2.0/WebConfigurationManager.cs:536 at System.Web.Configuration.WebConfigurationManager.GetSection (System.String sectionName, System.String path) [0x00000] in /var/tmp/portage/dev-lang/mono-3.12.0/work/mono-3.12.0/mcs/class/System.Web/System.Web.Configuration_2.0/WebConfigurationManager.cs:436 at System.Web.Configuration.WebConfigurationManager.GetWebApplicationSection (System.String sectionName) [0x0002c] in /var/tmp/portage/dev-lang/mono-3.12.0/work/mono-3.12.0/mcs/class/System.Web/System.Web.Configuration_2.0/WebConfigurationManager.cs:693 at System.Web.Compilation.BuildManager.GetReferencedAssemblies () [0x0004d] in /var/tmp/portage/dev-lang/mono-3.12.0/work/mono-3.12.0/mcs/class/System.Web/System.Web.Compilation/BuildManager.cs:1090 at System.Web.Compilation.BuildManager.CallPreStartMethods () [0x00013] in /var/tmp/portage/dev-lang/mono-3.12.0/work/mono-3.12.0/mcs/class/System.Web/System.Web.Compilation/BuildManager.cs:547

 

Well, not the best first experience with mojoPortal but I'm not ready to give it up yet if someone can help to cast some light on what's going on?

Thanks,

Joakim

2/25/2015 9:12:22 PM
Gravatar
Total Posts 1991

Re: Unable to load Setup of mojo-2.4.0.8 on Apache-2.2 mod_mono

Hi,

We stopped trying to support linux. For a number of years we did try to support it with Mono as a replacement for .NET but Mono never proved reliable enough for production use of mojoPortal and the effort trying to support it was too much so we gave up on it.

HTH,
Joe D.

2/26/2015 5:09:26 AM
Gravatar
Total Posts 18

Re: Unable to load Setup of mojo-2.4.0.8 on Apache-2.2 mod_mono

Gosh! I couldn't find anything about that reading through your site... but I understand the situation, although, Mono has made some real progress the latest years I believe, which is why I myself decided to give it a go, again. I do all my desktop work and programming on Windows, but have my business server on Linux since many years as I did find Windows too unreliable when I set it up almost 20 years ago.

So, am I in to a dead end here, again, or is this lack of NET/Mono compatibility with mojo something that one could possible be programming around in a sensible way? I mean, did you make a conscious breakage somewhere or is it more like you simple stopped bother about if a change would work with Mono or not?

As I'm looking at some future development of my online services and I had hoped to bridge the web part of my Linux server to sync with my desktop activity/programming on Windows by using an ASP.NET cms instead of my current one built on a stack of Drupal and WordPress in PHP. Among the alternatives I have come across so far, mojoPortal looked the most promising, both in regards of running on mod_mono and as a framework as such, so could you give me your sane judgement on if this is something that could be worked around with reasonable efforts? I have a time perspective of about 1-1 1/2 years when I would hope to deploy my new web service.

 Thanks,

Joakim

2/26/2015 9:22:07 AM
Gravatar
Total Posts 18444

Re: Unable to load Setup of mojo-2.4.0.8 on Apache-2.2 mod_mono

with Microsoft open sourcing most of .NET, it is possible that things will get better in Mono in the near future. Really if Mono is completely compatible with .NET it should just work, but it has not been the case till now. I think the Mono team is currently working on integrating a lot of open source bits from .NET to improve their implementation, so there is hope for the future.

2/26/2015 11:06:35 AM
Gravatar
Total Posts 18

Re: Unable to load Setup of mojo-2.4.0.8 on Apache-2.2 mod_mono

Ok thanks Joe,

Mono apparently has just branched for next release, which I think will be the first in the 4.0 series (3.12 now). So I will revisit this after they have released, but yes I know there is of course also the option to try out a hosted site.

2/27/2015 3:08:26 PM
Gravatar
Total Posts 18

Re: Unable to load Setup of mojo-2.4.0.8 on Apache-2.2 mod_mono

Actually one more thing or more something I just noticed. In the footer of my error page it says:


Version Information: 3.12.0 ((detached/a813491 Sat Feb 21 23:37:02 GMT 2015); ASP.NET Version: 4.0.30319.17020
 

3.12.0 is for Mono but what's puzzling me is, and maybe it's just because I don't fully grasp the semantics of ASP.NET yet, that it says ASP.NET version 4.0... but as far as what I understand my configuration and when I look at the running mono process

apache   29224  0.3  0.6 326452 12096 ?        Ssl  23:47   0:00 /usr/bin/mono /usr/lib/mono/4.5/mod-mono-server4.exe --filename /tmp/mod_mono_server_mono.mydomain.com --applications /:/var/www/mydomain.com/mono,/test:/usr/lib/xsp/test --nonstop

 I'm running ASP.NET 4.5 - or should at least, so does 4.0 refer to mojoPortal and there is simply a Framework mismatch? From the download files I understood though that MP is 4.5?

2/27/2015 3:14:50 PM
Gravatar
Total Posts 18444

Re: Unable to load Setup of mojo-2.4.0.8 on Apache-2.2 mod_mono

no, nothing specific to mojoportal, its just confusing semantics for .net versions, 4.5 is an in place upgrade for 4.0 and is still considered 4.0 clr/runtime similarly 3.5 .net was really 2.0 clr/runtime

so 4.5 is an upgraded version of 4.0, if 4.5 .net is installed it actually replaces any previous 4.0 version and the framework still reports itself as 4.0.....

only that last segment of the version would change for 4.5 vs 4.0

3/1/2015 6:09:26 PM
Gravatar
Total Posts 18

Re: Unable to load Setup of mojo-2.4.0.8 on Apache-2.2 mod_mono

Sorry, me again...

so 4.5 is an upgraded version of 4.0, if 4.5 .net is installed it actually replaces any previous 4.0 version and the framework still reports itself as 4.0.....

Is it really like that? I decided to download (clone) the source and load it in VS2013 (mojoportal.net40.sln), with the complaint,

Project Target Framework Not Installed

The C# project "mojoPortal.WEb.Controls" is targeting ".NETFramework,Version=v4.0, which is not installed on this machine. To proceed, select an option below.

0 Change the target to .NET Framework 4.5. You can change back to ".NETFramework, Version=v4.0" at a later time.

0 Download the targeting pack for ".NETFramework,Version=v4.0". The project will not change.

0 Do not load the project.

[OK]

This still may not contradict what you say, but I am not sure or at least weather it makes a difference to Mono or not, but if what you say is true, if I choose to download the v4.0 targeting pack will that not cause havoc if 4.5 is a replace of 4.0, so what is the sane thing to do here? I have 4.5 because that's what I target with my desktop projects and my goal is to make them interact with the ASP.NET site and code.

I realize this starts to go OT for installation and will take it to dev forum if further questions arise but still put this here as it connects to what you said above.

3/2/2015 7:11:29 AM
Gravatar
Total Posts 18

Re: Unable to load Setup of mojo-2.4.0.8 on Apache-2.2 mod_mono

I decided to take it over to Dev forum anyhow

https://www.mojoportal.com/Forums/Thread.aspx?pageid=5&t=13039~1#post53778

Unfortunately no way to edit post or I would have cleaned up and put the referencing url above.

You must sign in to post in the forums. This thread is closed to new posts.